package pl.otros.logview.filter;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

public class FilterPanel extends JPanel {

    private LogFilter logFilter;
    private JCheckBox box;
    private LogFilterValueChangeListener listener;

    public FilterPanel(LogFilter logFilter, LogFilterValueChangeListener listener) {
        super();
        this.logFilter = logFilter;
        this.listener = listener;
        this.setBorder(BorderFactory.createTitledBorder(logFilter.getName()));
        this.setLayout(new BorderLayout());
        this.setOpaque(true);
        logFilter.setValueChangeListener(listener);
        box = new JCheckBox("Enable/Disable filter");
        box.setSelected(logFilter.isEnable());
        box.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                FilterPanel.this.logFilter.setEnable(box.isSelected());
                FilterPanel.this.logFilter.getGUI().setEnabled(box.isSelected());
                FilterPanel.this.listener.valueChanged();
            }
        });        
        logFilter.getGUI().setEnabled(logFilter.isEnable());        
        this.add(box, BorderLayout.NORTH);
        this.add(FilterPanel.this.logFilter.getGUI(), BorderLayout.CENTER);
    }

}
