package pl.otros.logview.filter;

import javax.swing.RowFilter;

import pl.otros.logview.LogData;
import pl.otros.logview.gui.LogDataTableModel;


public class LogDataRowFilter extends RowFilter<LogDataTableModel, Integer> {

    public LogFilter[] filters;

    public LogDataRowFilter(LogFilter[] filters) {
        super();
        this.filters = filters;
    }

    public LogFilter[] getFilters() {
        return filters;
    }

    public void setFilters(LogFilter[] filters) {
        this.filters = filters;
    }

    @Override
    public boolean include(Entry<? extends LogDataTableModel, ? extends Integer> entry) {
        LogDataTableModel model = entry.getModel();
        LogData logData = model.getLogData(entry.getIdentifier());
        boolean result = true;
        for (int i = 0; i < filters.length; i++) {
            if (filters[i].isEnable()) {
                result = filters[i].accept(logData, i, model.isMarked(entry.getIdentifier()));
            }
            if (!result) {
                break;
            }
        }

        return result;
    }

}
