package pl.otros.logview.filter;

import java.util.ArrayList;
import java.util.Collection;

import javax.swing.table.TableRowSorter;

import pl.otros.logview.gui.LogDataTableModel;
import pl.otros.logview.gui.StatusObserver;


public class LogFilterValueChangeListener {

    private TableRowSorter<LogDataTableModel> rowSorter;
    private Collection<LogFilter> logFilters;
    private StatusObserver observer;

    public LogFilterValueChangeListener(TableRowSorter<LogDataTableModel> rowSorter, Collection<LogFilter> logFilters,
            StatusObserver statusObserver) {
        super();
        this.rowSorter = rowSorter;
        this.logFilters = logFilters;
        this.observer = statusObserver;
    }

    public void valueChanged() {

        ArrayList<LogFilter> enabledFiltersList = new ArrayList<LogFilter>();
        for (LogFilter logFilter : logFilters) {
            if (logFilter.isEnable()) {
                enabledFiltersList.add(logFilter);
            }
        }

        LogFilter[] enabledFilters = new LogFilter[enabledFiltersList.size()];
        enabledFilters = enabledFiltersList.toArray(enabledFilters);

        LogDataRowFilter dataRowFilter = new LogDataRowFilter(enabledFilters);
        rowSorter.setRowFilter(dataRowFilter);
        int filtered = rowSorter.getViewRowCount();
        if (filtered > 0) {
            observer.updateStatus(filtered + " messeges passed filters");
        } else {
            observer.updateStatus("No messages passed filters", StatusObserver.LEVEL_ERROR);
        }
    }
}
