package pl.otros.logview.filter;

import java.awt.Component;
import java.util.Properties;

import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import pl.otros.logview.LogData;
import pl.otros.logview.LogDataCollector;


public class RowNumberFilter implements LogFilter {

    private int start, stop;
    private boolean enableStart, enableStop;
    private boolean enable = true;
    private LogFilterValueChangeListener listener;
    private JPanel gui;
    private static final String NAME = "Row number filter";

    private RowNumberFilter() {
        gui = new JPanel();
    }

    @Override
    public boolean accept(LogData logData, int row, boolean marked) {
        boolean result = true;
        if (enableStart && row < start) {
            result = false;
        }
        if (result && enableStop && stop < row) {
            result = false;
        }

        return result;
    }

    @Override
    public Component getGUI() {
        return gui;
    }

    @Override
    public String getName() {
        return NAME;
    }

    @Override
    public void init(Properties properties, LogDataCollector collector) {

    }

    @Override
    public boolean isEnable() {
        return enable;
    }

    @Override
    public void setEnable(boolean enable) {
        this.enable = enable;

    }

    @Override
    public void setValueChangeListener(LogFilterValueChangeListener listener) {
        this.listener = listener;

    }

    private class ChangeListner implements ChangeListener {
        LogFilterValueChangeListener changeListener;

        public LogFilterValueChangeListener getChangeListener() {
            return changeListener;
        }

        public void setChangeListener(LogFilterValueChangeListener changeListener) {
            this.changeListener = changeListener;
        }

        @Override
        public void stateChanged(ChangeEvent e) {
            listener.valueChanged();

        }

    }
}
