package pl.otros.logview.gui;

import java.util.Arrays;
import java.util.Comparator;

import javax.swing.JMenu;
import javax.swing.JMenuItem;

public class GuiUtils {

    public static JMenu sortDirAndAlfabetic(JMenu root) {
        int count = root.getItemCount();
        JMenuItem[] items = new JMenuItem[count];
        for (int i = 0; i < count; i++) {
            items[i] = root.getItem(i);
        }
        Arrays.sort(items, new Comparator<JMenuItem>() {
            @Override
            public int compare(JMenuItem m1, JMenuItem m2) {
                if (m1.getClass().equals(m2.getClass())) {
                    return m1.getText().toLowerCase().compareTo(m2.getText().toLowerCase());
                } else if (m1 instanceof JMenu && !(m2 instanceof JMenu)) {
                    return -1;
                } else if (m2 instanceof JMenu && !(m1 instanceof JMenu)) {
                    return 1;
                }
                return 0;
            }
        });
        root.removeAll();
        for (JMenuItem menuItem : items) {
            if (menuItem instanceof JMenu) {
                menuItem = GuiUtils.sortDirAndAlfabetic((JMenu) menuItem);
            }
            root.add(menuItem);
        }
        return root;
    }

}
