package pl.otros.logview.gui;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JLabel;
import javax.swing.Timer;

public class JLabelStatusObserver implements StatusObserver {

    private Color colorNormal;
    private Color colorWarning = Color.YELLOW;
    private Color colorError = Color.RED;
    private JLabel label;

    public JLabelStatusObserver(JLabel label) {
        super();
        this.label = label;
        colorNormal = label.getBackground();
        label.setOpaque(true);
    }

    @Override
    public void updateStatus(String text) {
        updateStatus(text, StatusObserver.LEVEL_NORMAL);

    }

    @Override
    public void updateStatus(String text, int level) {
        label.setText(text);
        if (level == LEVEL_NORMAL) {
            label.setBackground(colorNormal);
        } else {
            BlinkActionListener listener = new BlinkActionListener();
            Timer timer = new Timer(100, listener);
            listener.timer = timer;
            listener.blinkColor = (level == LEVEL_WARNING) ? colorWarning : colorError;
            timer.setRepeats(true);
            timer.start();
        }
    }

    private class BlinkActionListener implements ActionListener {

        private Timer timer;
        private int count = 8;
        private Color blinkColor;

        @Override
        public void actionPerformed(ActionEvent e) {
            Color color = (count % 2 == 0) ? colorNormal : blinkColor;
            label.setBackground(color);
            count--;
            if (count <= 0) {
                timer.stop();
            }
        }

    }

}
