package pl.otros.logview.gui.actions;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.io.IOException;
import java.util.Map;
import java.util.jar.Attributes;
import java.util.jar.JarFile;

import javax.swing.AbstractAction;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class AboutAction extends AbstractAction {

    public JFrame frame;
    private String build = "?";

    public AboutAction(JFrame frame) {
        this.frame = frame;
        try {
            JarFile jarFile = new JarFile("logview.jar");
            Attributes map = jarFile.getManifest().getMainAttributes();            
            if (map.getValue("Implementation-Version") != null){                
                build = map.getValue("Implementation-Version");
            }
        } catch (IOException e) {
            System.err.println("Cannot load version from jarfile attribute");
        }
        
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        JPanel message = new JPanel(new GridLayout(3, 1));
        message.add(new JLabel("LogView"));
        message.add(new JLabel("Otros Systems"));
        message.add(new JLabel("Build: " + build));
        JOptionPane.showMessageDialog(frame, message, "About", JOptionPane.INFORMATION_MESSAGE);

    }

}
