package pl.otros.logview.gui.actions;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTable;

import pl.otros.logview.gui.FrameManger;
import pl.otros.logview.gui.LogDataTableModel;
import pl.otros.logview.gui.LogViewInternalFrame;
import pl.otros.logview.uml.LogViewTableWithUMLSynchronizer;
import pl.otros.logview.uml.LogdataConverter;
import pl.otros.logview.uml.UMLModel;


public class CreateUMLActionListener implements ActionListener {

    public CreateUMLActionListener() {

    }

    @Override
    public void actionPerformed(ActionEvent arg0) {
        try {
            LogViewInternalFrame lvFrame = FrameManger.getInstance().getActiveLogViewInternalFrame();
            if (lvFrame == null) {
                return;
            }

            LogDataTableModel dataTableModel = lvFrame.getDataTableModel();
            JTable table = lvFrame.getLogViewPanel().getTable();
            LogdataConverter converter = new LogdataConverter();
            UMLModel umlModel = converter.createJComponent(dataTableModel.getLogData());

            JFrame frame = new JFrame("UML");
            frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

            java.awt.Container cp = frame.getContentPane();

            cp.add(umlModel.getJComponent());

            frame.setSize(400, 400);
            frame.setLocation(400, 50);
            frame.setVisible(true);

            LogViewTableWithUMLSynchronizer synchronizer = new LogViewTableWithUMLSynchronizer(table, umlModel);
        } catch (Exception e) {
            JOptionPane.showMessageDialog((Component) arg0.getSource(), "Error Creating UML " + e.getMessage(), "Error",
                    JOptionPane.ERROR_MESSAGE);
            e.printStackTrace();
        }

    }

}
