package pl.otros.logview.gui.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashSet;
import java.util.LinkedList;

import javax.swing.JTable;

import pl.otros.logview.LogData;
import pl.otros.logview.gui.LogDataTableModel;
import pl.otros.logview.gui.StatusObserver;
import pl.otros.logview.uml.Message;
import pl.otros.logview.uml.Message.MessageType;

public class ShowCallHierarhyAction implements ActionListener {

    private JTable table;
    private LogDataTableModel model;
    private StatusObserver observer;
    
    public ShowCallHierarhyAction(JTable table, LogDataTableModel model, StatusObserver observer) {
        super();
        this.table = table;
        this.model = model;
        this.observer = observer;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        int selected = table.getSelectedRow();
        if (selected < 0){
            observer.updateStatus("Row not selected");
        }
        selected = table.convertRowIndexToModel(selected);
        LogData ld = model.getLogData(selected);
        String thread = ld.getThread();
        LogData[] lds  = model.getLogData();
        LinkedList<LogData> stack = new LinkedList<LogData>();
        HashSet<String> entrys = new HashSet<String>();
        HashSet<String> exits = new HashSet<String>();
        for (int i = 0; i < lds.length; i++) {
            LogData logData = lds[i];
            if (!logData.getThread().equals(thread)){
                continue;
            }
            Message m = new Message(logData.getMessage());
//            String s = "";
//            for (int j = 0; j < stack.size(); j++) {
//                s += " ";
//            }
            
            if (m.getType().equals(MessageType.TYPE_ENTRY)){
                stack.addLast(logData);
//                System.out.println(s + "+ : " + logData.getId()+ ": " + logData.getClazz() + "." + logData.getMethod() + ": " + logData.getMessage().substring(0, 4));
                entrys.add(logData.getClazz() + "." + logData.getMethod());
            } else if (m.getType().equals(MessageType.TYPE_EXIT) /*&& theSameLogMethod(stack.getLast(), logData)*/){
                stack.removeLast();
//                System.out.println(s + "-: " + logData.getId()+ ": " + logData.getClazz() + "." + logData.getMethod() + ": " + logData.getMessage().substring(0,4));
                exits.add(logData.getClazz() + "." + logData.getMethod());
            }
            if  (logData.getId() == ld.getId()){
                break;
            }
        }
//        System.out.println("ShowCallHierarhyAction.actionPerformed() have call hierarchy");
//        for (int i = 0; i < stack.size(); i++) {
//            LogData logData = stack.get(i);
//            System.out.println(logData.getId() + ": " + logData.getClazz() + "." + logData.getMethod() + ": " + logData.getMessage());
//        }
        
        
        System.out.println("ShowCallHierarhyAction.actionPerformed() printing lack of exits:");
        for (String entry : entrys) {
            if (!exits.contains(entry)){
                System.out.println(entry);
            }
        }
        

        
    }

    private boolean theSameLogMethod(LogData ld1, LogData ld2){
        return ld1.getMethod().equals(ld2.getMethod()) && ld1.getClazz().equals(ld2.getClazz()) ;
    }
}

