package pl.otros.logview.gui.actions;

import java.awt.event.ActionEvent;
import java.io.IOException;

import javax.swing.AbstractAction;
import javax.swing.Action;

import pl.otros.logview.gui.StatusObserver;
import pl.otros.logview.reader.SocketLogReader;

public class StartSocketListener extends AbstractAction {

    private int port = 50505;
    private SocketLogReader logReader = null;
    private StatusObserver observer;

    public StartSocketListener(StatusObserver observer) {
        this.observer = observer;
        putValue(Action.NAME, "Start socket listener on port " + port);
        putValue(Action.SHORT_DESCRIPTION, "Start socket listener on port " + port + ". Log have to  be formated by java.util.logging.XMLFormatter.");
        putValue(Action.LONG_DESCRIPTION, "Start socket listener on port " + port + ". Log have to  be formated by java.util.logging.XMLFormatter.");
    }

    @Override
    public void actionPerformed(ActionEvent arg0) {
        if (logReader == null || logReader.isClosed()) {
            logReader = new SocketLogReader();
            
            try {
                logReader.start(port);
                putValue(Action.NAME, "Close socket listener");                
                observer.updateStatus("Socket opened on port " + port + " with java.util.logging.XMLFormatter.");
            } catch (Exception e) {
                e.printStackTrace();
                observer.updateStatus("Failed to open listener " + e.getMessage(), StatusObserver.LEVEL_ERROR);
            }
        } else {
            try {
                logReader.close();
                putValue(Action.NAME, "Start socket listener on port " + port);
                observer.updateStatus("Socket closed, log listening finished.");
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                observer.updateStatus("Failed to close listener " + e.getMessage(), StatusObserver.LEVEL_ERROR);
            }
        }
    }

}
