package pl.otros.logview.gui.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JTable;

import pl.otros.logview.gui.MarkableTableModel;
import pl.otros.logview.gui.StatusObserver;


public class UnMarkRowAction implements ActionListener {

    private JTable table;
    private MarkableTableModel model;
    private StatusObserver observer;

    public UnMarkRowAction(JTable table, MarkableTableModel model, StatusObserver observer) {
        this.table = table;
        this.model = model;
        this.observer = observer;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        int[] selected = table.getSelectedRows();
        for (int i = 0; i < selected.length; i++) {
            selected[i] = table.convertRowIndexToModel(selected[i]);
        }
        model.unmarkRows(selected);
        if (observer != null) {
            observer.updateStatus(selected.length + " rows unmarked");
        }
    }

}
