package pl.otros.logview.gui.markers;

import pl.otros.logview.LogData;

public class BadWordsMarker implements AutomaticMarker {

    private static final String NAME = "Null, Error, Fail, Exception, Severe";
    private static final String DESCRIPTION = "Marks messages with Null, Error, Fail , exception, severe in message";

    @Override
    public String getDescripion() {
        return DESCRIPTION;
    }

    @Override
    public String getName() {
        return NAME;
    }

    @Override
    public boolean toMark(LogData data) {
        String m = data.getMessage().toLowerCase();
        return m.contains("fail") || m.contains("error") || m.contains("null") || m.contains("exceptions")
                || m.contains("severe");
    }

    @Override
    public String toString() {
        return NAME;
    }

    @Override
    public String[] getMarkerGroups() {
        return new String[] { "", "Errors" };
    }

}
