package pl.otros.logview.gui.markers;

import pl.otros.logview.LogData;

public class NullMarker implements AutomaticMarker {

    private static final String NAME = "Null logged";
    private static final String DESCRIPTION = "Marks messages with null in message";

    @Override
    public String getDescripion() {
        return DESCRIPTION;
    }

    @Override
    public String getName() {
        return NAME;
    }

    @Override
    public boolean toMark(LogData data) {
        String m = data.getMessage().toLowerCase();
        return m.contains("null");
    }

    @Override
    public String toString() {
        return NAME;
    }

    @Override
    public String[] getMarkerGroups() {
        return new String[] { "", "Errors" };
    }

}