package pl.otros.logview.gui.renderers;

import java.awt.Color;
import java.awt.Component;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;


public class DateRenderer implements TableCellRenderer {

    private JLabel label = new JLabel();
    private DateFormat dateFormatter = null;
    private Color orygianlBackGround;
    private Color selectedColor;
    private Color markedColor;
    private Color markedSelectedColor;

    public DateRenderer() {
        this("hh:mm:ss .SSS");
    }

    public DateRenderer(String dateFormat) {
        label.setOpaque(true);
        dateFormatter = new SimpleDateFormat(dateFormat);
        orygianlBackGround = label.getBackground();
        selectedColor = Color.CYAN;
        markedColor = Color.MAGENTA;
        markedSelectedColor = new Color(255, 140, 255);
    }

    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row,
            int column) {
        if (value instanceof Date) {
            Date date = (Date) value;
            label.setText(dateFormatter.format(date));
        } else {
            label.setText("");
        }

        return label;
    }

    public DateFormat getDateFormatter() {
        return dateFormatter;
    }

    public void setDateFormatter(DateFormat dateFormatter) {
        this.dateFormatter = dateFormatter;
    }

}
