package pl.otros.logview.gui.renderers;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

public class StripesDecoratorRenderer implements TableCellRenderer {

    private TableCellRenderer subjectRenderer;

    public StripesDecoratorRenderer(TableCellRenderer subjectRenderer) {
        super();
        this.subjectRenderer = subjectRenderer;
    }

    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row,
            int column) {
        Component c = subjectRenderer.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
        if (row % 2 == 0) {
            // c.
            Color color = c.getBackground();
            float shift = 0.1f;
            float[] colorHSB = Color.RGBtoHSB(color.getRed(), color.getGreen(), color.getBlue(), null);
            // if (colorHSB[2] > 0.5f) {
            // shift = shift * -1;
            // }
            colorHSB[2] += shift;
            color = new Color(Color.HSBtoRGB(colorHSB[0], colorHSB[1], colorHSB[2]));
            c.setBackground(color);
        }

        return c;
    }

}
