package pl.otros.logview.importer;

import java.awt.event.KeyEvent;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import javax.swing.Icon;


import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

import pl.otros.logview.LogDataCollector;
import pl.otros.logview.parser.LogHandler;

public class XMLLogImporter implements LogImporter {

    private String displayableName = "XML";

    @Override
    public void init(Properties properties) {

    }

    @Override
    public void importLogs(InputStream in, LogDataCollector dataTableModel, boolean addAllDataOnFinish) {
        XMLReader parser;
        try {
            parser = XMLReaderFactory.createXMLReader();
            LogHandler handler = new LogHandler(dataTableModel);
            parser.setContentHandler(handler);
            parser.setDTDHandler(handler);
            parser.setEntityResolver(handler);
            parser.parse(new InputSource(in));
        } catch (SAXException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    @Override
    public String getDisplayableName() {
        return displayableName;
    }

    @Override
    public String getKeyStrokeAccelelator() {
        return "control l";
    }

    @Override
    public int getMnemonic() {
        return KeyEvent.VK_L;
    }

    @Override
    public Icon getIcon() {
        return null;
    }

}
