package pl.otros.logview.uml;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

public class LifelinePainter implements ExtraPainter {

    private int[] xPositions;
    private Color color;

    public LifelinePainter(int[] positions, Color color) {
        super();
        xPositions = positions;
        this.color = color;
    }

    @Override
    public void paint(Graphics g, Rectangle view) {
        g.setColor(color);
        for (int i = 0; i < xPositions.length; i++) {
            if (xPositions[i] > view.x && xPositions[i] < view.x + view.width) {
                double y = view.getY();
                while (y < view.getY() + view.getHeight()) {
                    g.drawLine(xPositions[i], (int) y, xPositions[i], (int) y + 5);
                    y += 10;
                }

            }
        }

    }

}
