package pl.otros.logview.uml;

import java.awt.Point;
import java.util.LinkedHashMap;

public class LogUmlMapper {

    private LinkedHashMap<Integer, Point> idToPointMap;

    public LogUmlMapper() {
        idToPointMap = new LinkedHashMap<Integer, Point>();
    }

    public void addMapping(int logId, Point p) {
        idToPointMap.put(logId, p);
    }

    public Point getPoint(int logId) {
        return idToPointMap.get(logId);
    }

    public int getLogId(int yPosition) {
        int lastDistance = Integer.MAX_VALUE;
        for (Integer id : idToPointMap.keySet()) {
            Point p = idToPointMap.get(id);
            if (Math.abs(p.y - yPosition) <= lastDistance) {
                lastDistance = Math.abs(p.y - yPosition);
            } else {
                return id;
            }
        }
        return 0;
    }
}
