package pl.otros.logview.uml;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;

import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class LogViewTableWithUMLSynchronizer implements AdjustmentListener, ListSelectionListener {

    private JTable table;
    private LogUmlMapper logUmlMapper;
    private UMLModel umlModel;

    public LogViewTableWithUMLSynchronizer(JTable table2, UMLModel umlModel) {
        this.table = table2;
        this.umlModel = umlModel;
        logUmlMapper = umlModel.getLogUmlMapper();
        table.getSelectionModel().addListSelectionListener(this);

        JScrollPane sp = umlModel.getScrollPane();
        JScrollBar sb = sp.getVerticalScrollBar();
        sb.addAdjustmentListener(this);
        umlModel.getScrollPane().getVerticalScrollBar().addAdjustmentListener(this);

    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
        if (e.getSource() == umlModel.getScrollPane().getVerticalScrollBar()) {
            JScrollBar bar = (JScrollBar) e.getSource();
            int row = logUmlMapper.getLogId(bar.getValue());
            Rectangle r = table.getCellRect(row, 0, true);
            table.scrollRectToVisible(r);

        } else if (e.getSource() == table) {
        }

    }

    @Override
    public void valueChanged(ListSelectionEvent e) {
        int row = table.getSelectedRow();
        Integer o = (Integer) table.getValueAt(row, 0);
        Point p = logUmlMapper.getPoint(o);
        if (p != null) {
            Rectangle r = new Rectangle(logUmlMapper.getPoint(o));
            umlModel.getContentJComponet().scrollRectToVisible(r);
        }

    }

}
