package pl.otros.logview.uml;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Rectangle;

public class StringShape {

    private String string;
    private Font font;
    private int centerX;
    private int centerY;
    private Color color;

    public StringShape(String string, Font font, int centerX, int centerY, Color color) {
        super();
        if (string.length() == 0) {
            string = " ";
        }
        this.string = string;
        this.font = font;
        this.centerX = centerX;
        this.centerY = centerY;
        this.color = color;
    }

    public String getString() {
        return string;
    }

    public void setString(String string) {
        if (string.length() == 0) {
            string = " ";
        }
        this.string = string;
    }

    public Font getFont() {
        return font;
    }

    public void setFont(Font font) {
        this.font = font;
    }

    public Rectangle getRectangle(FontMetrics fm) {
        int height = fm.getHeight();
        int width = fm.stringWidth(string);
        Rectangle r = new Rectangle(centerX - width / 2, centerY - height / 2, centerX + width / 2, centerY / width / 2);
        return r;
    }

    public Color getColor() {
        return color;
    }
}
